{$define dosok}

{$ifdef dosok}
uses dos;
{$endif}

	const ver='look_map 1.1';

{ change these if you need to}

{ size of string array with useful lines of map file read in}
const max_lines=5000;

{ max no of modules in link map}
      max_mods=50;

      max_len=255;

var map:array [0..max_lines] of string[max_len];
    fin, fout:text;

    infile, outfile, s, options:string[max_len];
    no_lines,i,j,k,l, load_line,p,size, tsize, bsize,osize, 
       dsize, isize, fsize, csize :longint;
    
    mod_names:array[1..max_mods] of string[max_len];
    debug, readfl:boolean;

{$ifdef dosok}
    dt:datetime;
{$endif}

    stime,marker:string;
    time,n:longint;

procedure error(s:string);
begin
writeln(ver,' error:', s);
halt(1);
end;


Function L0(w:word):string;
var  s : string;
              begin
                Str(w,s);
                if w<10 then
                 L0:='0'+s
                else
                 L0:=s;
              end;


{ converts hex string (lower case) to longint, terminator space or legth of string}
{ nb non hex digits ignored}
function str_no(s:string):longint;
var j, tot,n:longint;
begin

tot:=0;
j:=1;

repeat
tot:=tot*16;

n:=0;
if ( (s[j]>='0') and (s[j]<='9') ) then n:=ord(s[j])-ord('0');
if ( (s[j]>='a') and (s[j]<='f') ) then n:=ord(s[j])-ord('a')+10;
tot:=tot+n;
j:=j+1;

until ( (s[j]=' ') or (j>length(s)) );

str_no:=tot;

end;



begin

debug:=false;

infile:=paramstr(1);
if infile='' then infile:='mapop.map';
if infile='' then begin writeln('no file name-',infile); halt(1); end;

if ( (infile='?') or (infile='h')) then
begin
writeln('look_map [infile] [outfile] [options]');
writeln(' infile is i/p filename (defaults to mapop.map), outfile is o/p filename');
writeln('  analyses map o/p from ld/ldw & outputs to console + outfile');
writeln('   a list of the modules used & their sizes + total');
writeln('  useful with smartlinking to see what is happening');
writeln('  to get map o/p use "-k-Map filename" as parameter in fpc');
writeln(' sets errorlevel ne 0 if error');
writeln;
writeln('o/p is: module name, sizes: total, .text, .bss, .data, .idata, common');
writeln;
writeln(' fpc, works with win32 & go32v2, release 99.14 onwards');
writeln(' ',ver, ' John Lee, leej@logica.com');
halt;
end;


outfile:=paramstr(2);
if outfile='' then outfile:='map.tmp';
if outfile='' then begin writeln('error no file name -',outfile); halt(1);     end;

options:=lowercase(paramstr(3));

{
writeln('look_map:  infile, outfile, options=', infile, ' ',outfile, ' ',options); 
}

{$i-}
assign(fin,infile);
reset(fin);
if ioresult<>0 then begin writeln('error cannot read file-',infile); halt(1);  end;
{$i+}


stime:='';

{$ifdef dosok}
GetFTime(fin,Time);
UnPackTime(Time,DT);

stime:=L0(DT.day)+'/'+L0(word(DT.month))+'/'+copy(l0(DT.Year),3,2);
stime:=stime + ' '+L0(DT.Hour)+':'+L0(DT.Min);
{$endif}


{$i-}
assign(fout, outfile); 
rewrite(fout);
if ioresult<>0 then begin writeln('error cannot write file-',outfile); halt(1);  end;
{$i+}

{ start storing after allocating found previous stuff is crap}
readfl:=false;
no_lines:=0;
n:=0;
{ marks start of useful date}
marker:='configuration';


while not eof(fin) do 
begin
n:=n+1;
readln(fin, s);
s:=lowercase(s);
if pos(marker,s)>0 then 
begin 
{
writeln(' start storing at line ',n);
}
readfl:=true; 
end; 

if readfl then
begin
map[no_lines]:=s;
no_lines:=no_lines+1;
end;
if no_lines>max_lines then 
 begin writeln('error too many lines, max_lines=',max_lines); halt(1); end;
end;
close(fin);

if not readfl then
begin
writeln(' error text ', marker, ' not found--  pls notify leej@logica.com');
halt(1);  
end;

if debug then writeln('no lines-',no_lines);


writeln(fout, ' i/p map file was ', infile, ' ',stime);
writeln(fout, ' modules loaded ');
writeln(fout);


load_line:=0;
k:=1;

for j:=0 to no_lines do 
begin


s:='load ';
if pos(s, map[j]) >0  then 
begin 
{ writeln(map[j]); }

{ look for last load} 
load_line:=j;

 mod_names[k]:=copy(map[j],length(s)+1,100);

if debug then  writeln(k, ' ',mod_names[k]);

 writeln(fout, k, ' ',mod_names[k]);
 
 k:=k+1;
 if k>max_mods then begin  writeln(' error too many module names, max_mods=',max_mods); halt(1);end;
end;
end;
k:=k-1;

{start line for rest of program, 1 after the last load}
load_line:=load_line+1;

write(ver, ' i/p file name:', infile, ', linked ',stime);
writeln(', no of modules=',k);

if debug then writeln('no of mod names, end_line=', k, ' ',load_line);

osize:=0;

fsize:=0;
{for all mod_names}
for l:=1 to k do
begin
write(mod_names[l]); 
writeln(fout,'-',mod_names[l]); 

size:=0;
tsize:=0;
dsize:=0;
bsize:=0;
isize:=0;

csize:=0;

{search whole map after line with end }
for j:=load_line to no_lines do
begin

{fill is not asociated with any module}
if pos('*fill',map[j])>0 then 
begin

s:=map[j];
p:=pos('0x',s);
if p>0 then delete(s,1,p+1) else write (' no 1st hex ln:',j, ' ');

p:=pos('0x',s);
if p>0 then delete(s,1,p+1);
fsize:=fsize+str_no(s);

end;


if pos(mod_names[l],map[j])>0  then
begin

{found module name so get 2nd hex string (the size)}
s:=map[j];

p:=pos('0x',s);
if p>0 then delete(s,1,p+1) else write ('NB no 1st hex no ln:',j, ' ');

p:=pos('0x',s);
if p>0 then delete(s,1,p+1) else 
begin
writeln('error NB no 2nd lex no ln:', j);
halt(1);
end;


if ( (pos('common',map[j])<=0) and (pos('.bss', map[j])<=0) ) then 
begin
size:=size+str_no(s);
end;

if pos('.text',map[j])>0 then tsize:=tsize+str_no(s);


if pos('.bss',map[j])>0 then bsize:=bsize+str_no(s);


if pos('.data',map[j])>0 then dsize:=dsize+str_no(s);
if pos('.idata',map[j])>0 then isize:=isize+str_no(s);
{
if pos('common',map[j])>0 then csize:=csize+str_no(s);
}

if options='d' then
begin
k:=1;

while (pos('.',map[j+k]) <1 ) do 
begin
writeln(fout, copy(map[j],1,10)+copy(map[j+k], 40,30));
k:=k+1;
end; 

end; {if option=d}

{
writeln(fout,map[j]);
}
end;{if mod name found} 

end; {j loop}

write(' ',size);
write(' ',tsize, ' ', bsize, ' ', dsize, ' ',isize, ' ',csize);
writeln(' (',tsize+bsize+dsize+isize+csize,')'); 
write(fout, 'sizes: total, text, bss, data, idata, common=',size);
write(fout, ' ',tsize, ' ', bsize, ' ', dsize, ' ',isize, ' ',csize);
writeln(fout,' (',tsize+bsize+dsize+isize+csize,')'); 

osize:=osize+size;

end; {l loop}

writeln;
writeln('linked size, *fill size=',osize,' ',fsize);
writeln(fout, 'linked size, *fill size=',osize,' ',fsize);

close(fout);


end.